import scrapy

from mainTainsouh.items import MaintainsouhItem


class MaintainSpider(scrapy.Spider):
    name = 'maintain'
    allowed_domains = ['auto.sohu.com']
    start_urls = ['http://db.auto.sohu.com/home/']

    def parse(self, response, **kwargs):
        all_brand_li = response.xpath('//*[@id="treeNav"]/ul/li[@class="close_child"]')
        for i in all_brand_li:
            all_maker_li = i.xpath("ul")
            for j in all_maker_li:
                all_series_li = j.xpath('li/a[@class="model-a"]')
                for k in all_series_li:
                    # 获取车型保养信息地址
                    maintain_url = 'http:' + k.attrib.get('href') + '/maintenance.html'
                    yield scrapy.Request(maintain_url, callback=self.parse_maintain)

    def parse_maintain(self, response, **kwargs):
        all_maintain_tb = response.xpath('//*[@id="type_tb_L"]/div')
        # 遍历车系下所有车款
        for i in all_maintain_tb:
            maintain = MaintainsouhItem()
            maintain['style_id'] = i.attrib.get('id')[4:-2]
            value = []
            all_item = i.xpath('table[1]/thead/tr/th')
            all_item_v = i.xpath('table[1]/tbody/tr')
            # 遍历所有项目item
            for j in range(1, 11):
                item1 = all_item[j].xpath('text()')
                #  拼接item内容并去掉非数字文字字母字符
                item = ''
                if len(item1) > 1:
                    item = (str(item1[0].root) + "" + str(item1[1].root)).strip()
                else:
                    item = str(item1[0].root)

                # 遍历所有里程
                item_list = []
                for k in all_item_v:
                    item_v = k.xpath('td')
                    item_list.append({"mile": item_v[0].xpath('text()')[0].root,
                                      "level": "2" if item_v[j].xpath('text()')[0].root == "●" else "0"})
                value.append({"item": item, "items": item_list})
            maintain['maintain_v'] = str(value)
            all_price = i.xpath('table[2]/tbody/tr')
            price = []
            for l in all_price:
                price_dict = {}
                td = l.xpath('td')
                price.append(
                    {"item": '' if len(td[0].xpath('text()')) == 0 else str(td[0].xpath('text()')[0].root).strip(),
                     "price": '' if len(td[1].xpath('text()')) == 0 else str(td[1].xpath('text()')[0].root).strip(),
                     "other": '' if len(td[2].xpath('text()')) == 0 else str(td[2].xpath('text()')[0].root).strip()})
                price.append(
                    {"item": '' if len(td[3].xpath('text()')) == 0 else str(td[3].xpath('text()')[0].root).strip(),
                     "price": '' if len(td[4].xpath('text()')) == 0 else str(td[4].xpath('text()')[0].root).strip(),
                     "other": '' if len(td[5].xpath('text()')) == 0 else str(td[5].xpath('text()')[0].root).strip()})
            maintain['reference_price'] = str(price[0:-1])
            yield maintain
